<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>InMemoryNodeModel (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="InMemoryNodeModel (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10,"i25":10,"i26":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/InMemoryNodeModel.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.Builder.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModelSupport.html" title="interface in org.apache.commons.configuration2.tree"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/tree/InMemoryNodeModel.html" target="_top">Frames</a></li>
<li><a href="InMemoryNodeModel.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2.tree</div>
<h2 title="Class InMemoryNodeModel" class="title">Class InMemoryNodeModel</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.apache.commons.configuration2.tree.InMemoryNodeModel</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">InMemoryNodeModel</span>
extends <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements <a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</pre>
<div class="block"><p>
 A specialized node model implementation which operates on
 <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree"><code>ImmutableNode</code></a> structures.
 </p>
 <p>
 This <code>NodeModel</code> implementation keeps all its data as a tree of
 <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree"><code>ImmutableNode</code></a> objects in memory. The managed structure can be
 manipulated in a thread-safe, non-blocking way. This is achieved by using
 atomic variables: The root of the tree is stored in an atomic reference
 variable. Each update operation causes a new structure to be constructed
 (which reuses as much from the original structure as possible). The old root
 node is then replaced by the new one using an atomic compare-and-set
 operation. If this fails, the manipulation has to be done anew on the updated
 structure.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: InMemoryNodeModel.java 1790899 2017-04-10 21:56:46Z ggregory $</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#InMemoryNodeModel--">InMemoryNodeModel</a></span>()</code>
<div class="block">Creates a new instance of <code>InMemoryNodeModel</code> which is initialized
 with an empty root node.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#InMemoryNodeModel-org.apache.commons.configuration2.tree.ImmutableNode-">InMemoryNodeModel</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;root)</code>
<div class="block">Creates a new instance of <code>InMemoryNodeModel</code> and initializes it
 from the given root node.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#addNodes-java.lang.String-java.util.Collection-org.apache.commons.configuration2.tree.NodeKeyResolver-">addNodes</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
        <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;nodes,
        <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Adds a collection of new nodes to this model.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#addNodes-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-java.util.Collection-org.apache.commons.configuration2.tree.NodeKeyResolver-">addNodes</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
        <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
        <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;nodes,
        <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Adds new nodes using a tracked node as root node.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#addProperty-java.lang.String-java.lang.Iterable-org.apache.commons.configuration2.tree.NodeKeyResolver-">addProperty</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
           <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;?&gt;&nbsp;values,
           <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Adds a new property to this node model consisting of an arbitrary number
 of values.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#addProperty-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-java.lang.Iterable-org.apache.commons.configuration2.tree.NodeKeyResolver-">addProperty</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
           <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
           <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;?&gt;&nbsp;values,
           <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Adds new property values using a tracked node as root node.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#clear-org.apache.commons.configuration2.tree.NodeKeyResolver-">clear</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Removes all data from this model.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#clearProperty-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">clearProperty</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
             <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Clears the value of a property.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#clearProperty-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-org.apache.commons.configuration2.tree.NodeKeyResolver-">clearProperty</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
             <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
             <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Clears a property using a tracked node as root node.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#clearTree-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">clearTree</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
         <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Removes the sub trees defined by the given key from this model.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#clearTree-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-org.apache.commons.configuration2.tree.NodeKeyResolver-">clearTree</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
         <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
         <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Clears a whole sub tree using a tracked node as root node.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#getInMemoryRepresentation--">getInMemoryRepresentation</a></span>()</code>
<div class="block">Returns a representation of the data stored in this model in form of a
 nodes hierarchy of <code>ImmutableNode</code> objects.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#getNodeHandler--">getNodeHandler</a></span>()</code>
<div class="block">Returns a <code>NodeHandler</code> for dealing with the nodes managed by this
 model.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/tree/ReferenceNodeHandler.html" title="interface in org.apache.commons.configuration2.tree">ReferenceNodeHandler</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#getReferenceNodeHandler--">getReferenceNodeHandler</a></span>()</code>
<div class="block">Returns a <code>ReferenceNodeHandler</code> object for this model.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#getRootNode--">getRootNode</a></span>()</code>
<div class="block">Returns the root node of this mode.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#getTrackedNode-org.apache.commons.configuration2.tree.NodeSelector-">getTrackedNode</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector)</code>
<div class="block">Returns the current <code>ImmutableNode</code> instance associated with the
 given <code>NodeSelector</code>.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#getTrackedNodeHandler-org.apache.commons.configuration2.tree.NodeSelector-">getTrackedNodeHandler</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector)</code>
<div class="block">Returns a <code>NodeHandler</code> for a tracked node.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#isTrackedNodeDetached-org.apache.commons.configuration2.tree.NodeSelector-">isTrackedNodeDetached</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector)</code>
<div class="block">Returns a flag whether the specified tracked node is detached.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#mergeRoot-org.apache.commons.configuration2.tree.ImmutableNode-java.lang.String-java.util.Map-java.lang.Object-org.apache.commons.configuration2.tree.NodeKeyResolver-">mergeRoot</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node,
         <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;rootName,
         <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>,?&gt;&nbsp;references,
         <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;rootRef,
         <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Merges the root node of this model with the specified node.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#replaceRoot-org.apache.commons.configuration2.tree.ImmutableNode-org.apache.commons.configuration2.tree.NodeKeyResolver-">replaceRoot</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;newRoot,
           <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Replaces the root node of this model.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#replaceTrackedNode-org.apache.commons.configuration2.tree.NodeSelector-org.apache.commons.configuration2.tree.ImmutableNode-">replaceTrackedNode</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
                  <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;newNode)</code>
<div class="block">Replaces a tracked node by another node.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#selectAndTrackNodes-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">selectAndTrackNodes</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                   <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Allows tracking all nodes selected by a key.</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#setProperty-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-java.lang.Object-org.apache.commons.configuration2.tree.NodeKeyResolver-">setProperty</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
           <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
           <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;value,
           <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Sets the value of a property using a tracked node as root node.</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#setProperty-java.lang.String-java.lang.Object-org.apache.commons.configuration2.tree.NodeKeyResolver-">setProperty</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
           <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;value,
           <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Changes the value of a property.</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#setRootNode-org.apache.commons.configuration2.tree.ImmutableNode-">setRootNode</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;newRoot)</code>
<div class="block">Sets a new root node for this model.</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#trackChildNodes-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">trackChildNodes</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
               <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Tracks all nodes which are children of the node selected by the passed in
 key.</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#trackChildNodeWithCreation-java.lang.String-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">trackChildNodeWithCreation</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                          <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;childName,
                          <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Tracks a node which is a child of another node selected by the passed in
 key.</div>
</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#trackNode-org.apache.commons.configuration2.tree.NodeSelector-org.apache.commons.configuration2.tree.NodeKeyResolver-">trackNode</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
         <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</code>
<div class="block">Adds a node to be tracked.</div>
</td>
</tr>
<tr id="i26" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#untrackNode-org.apache.commons.configuration2.tree.NodeSelector-">untrackNode</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector)</code>
<div class="block">Removes a tracked node.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="InMemoryNodeModel--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>InMemoryNodeModel</h4>
<pre>public&nbsp;InMemoryNodeModel()</pre>
<div class="block">Creates a new instance of <code>InMemoryNodeModel</code> which is initialized
 with an empty root node.</div>
</li>
</ul>
<a name="InMemoryNodeModel-org.apache.commons.configuration2.tree.ImmutableNode-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>InMemoryNodeModel</h4>
<pre>public&nbsp;InMemoryNodeModel(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;root)</pre>
<div class="block">Creates a new instance of <code>InMemoryNodeModel</code> and initializes it
 from the given root node. If the passed in node is <b>null</b>, a new,
 empty root node is created.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>root</code> - the new root node for this model</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getRootNode--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRootNode</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;getRootNode()</pre>
<div class="block">Returns the root node of this mode. Note: This method should be used with
 care. The model may be updated concurrently which causes the root node to
 be replaced. If the root node is to be processed further (e.g. by
 executing queries on it), the model should be asked for its
 <code>NodeHandler</code>, and the root node should be obtained from there. The
 connection between a node handler and its root node remain constant
 because an update of the model causes the whole node handler to be
 replaced.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the current root node</dd>
</dl>
</li>
</ul>
<a name="getNodeHandler--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNodeHandler</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;getNodeHandler()</pre>
<div class="block">Returns a <code>NodeHandler</code> for dealing with the nodes managed by this
 model. <code>InMemoryNodeModel</code> implements the
 <code>NodeHandler</code> interface itself. So this implementation just returns
 the <strong>this</strong> reference.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#getNodeHandler--">getNodeHandler</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <code>NodeHandler</code></dd>
</dl>
</li>
</ul>
<a name="addProperty-java.lang.String-java.lang.Iterable-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addProperty</h4>
<pre>public&nbsp;void&nbsp;addProperty(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                        <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;?&gt;&nbsp;values,
                        <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#addProperty-java.lang.String-java.lang.Iterable-org.apache.commons.configuration2.tree.NodeKeyResolver-">NodeModel</a></code></span></div>
<div class="block">Adds a new property to this node model consisting of an arbitrary number
 of values. The key for the add operation is provided. For each value a
 new node has to be added. The passed in resolver is queried for a
 <a href="../../../../../org/apache/commons/configuration2/tree/NodeAddData.html" title="class in org.apache.commons.configuration2.tree"><code>NodeAddData</code></a> object defining the add operation to be performed.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#addProperty-java.lang.String-java.lang.Iterable-org.apache.commons.configuration2.tree.NodeKeyResolver-">addProperty</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key</dd>
<dd><code>values</code> - the values to be added at the position defined by the key</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
</dl>
</li>
</ul>
<a name="addProperty-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-java.lang.Iterable-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addProperty</h4>
<pre>public&nbsp;void&nbsp;addProperty(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                        <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
                        <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;?&gt;&nbsp;values,
                        <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Adds new property values using a tracked node as root node. This method
 works like the normal <code>addProperty()</code> method, but the origin of the
 operation (also for the interpretation of the passed in key) is a tracked
 node identified by the passed in <code>NodeSelector</code>. The selector can
 be <b>null</b>, then the root node is assumed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key</dd>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the root node (or
        <b>null</b>)</dd>
<dd><code>values</code> - the values to be added</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector cannot be resolved</dd>
</dl>
</li>
</ul>
<a name="addNodes-java.lang.String-java.util.Collection-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addNodes</h4>
<pre>public&nbsp;void&nbsp;addNodes(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                     <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;nodes,
                     <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#addNodes-java.lang.String-java.util.Collection-org.apache.commons.configuration2.tree.NodeKeyResolver-">NodeModel</a></code></span></div>
<div class="block">Adds a collection of new nodes to this model. This operation corresponds
 to the <code>addNodes()</code> method of the <code>HierarchicalConfiguration</code>
 interface. The new nodes are either added to an existing node (if the
 passed in key selects exactly one node) or to a newly created node. The
 passed in <code>NodeKeyResolver</code> is used to interpret the given key.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#addNodes-java.lang.String-java.util.Collection-org.apache.commons.configuration2.tree.NodeKeyResolver-">addNodes</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key</dd>
<dd><code>nodes</code> - the collection of nodes to be added (may be <b>null</b>)</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
</dl>
</li>
</ul>
<a name="addNodes-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-java.util.Collection-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addNodes</h4>
<pre>public&nbsp;void&nbsp;addNodes(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                     <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
                     <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;nodes,
                     <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Adds new nodes using a tracked node as root node. This method works like
 the normal <code>addNodes()</code> method, but the origin of the operation
 (also for the interpretation of the passed in key) is a tracked node
 identified by the passed in <code>NodeSelector</code>. The selector can be
 <b>null</b>, then the root node is assumed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key</dd>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the root node (or
        <b>null</b>)</dd>
<dd><code>nodes</code> - the collection of new nodes to be added</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector cannot be resolved</dd>
</dl>
</li>
</ul>
<a name="setProperty-java.lang.String-java.lang.Object-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setProperty</h4>
<pre>public&nbsp;void&nbsp;setProperty(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                        <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;value,
                        <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#setProperty-java.lang.String-java.lang.Object-org.apache.commons.configuration2.tree.NodeKeyResolver-">NodeModel</a></code></span></div>
<div class="block">Changes the value of a property. This is a more complex operation as it
 might involve adding, updating, or deleting nodes and attributes from the
 model. The object representing the new value is passed to the
 <code>NodeKeyResolver</code> which will produce a corresponding
 <a href="../../../../../org/apache/commons/configuration2/tree/NodeUpdateData.html" title="class in org.apache.commons.configuration2.tree"><code>NodeUpdateData</code></a> object. Based on the content of this object,
 update operations are performed.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#setProperty-java.lang.String-java.lang.Object-org.apache.commons.configuration2.tree.NodeKeyResolver-">setProperty</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key</dd>
<dd><code>value</code> - the new value for this property (to be evaluated by the
        <code>NodeKeyResolver</code>)</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
</dl>
</li>
</ul>
<a name="setProperty-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-java.lang.Object-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setProperty</h4>
<pre>public&nbsp;void&nbsp;setProperty(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                        <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
                        <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;value,
                        <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Sets the value of a property using a tracked node as root node. This
 method works like the normal <code>setProperty()</code> method, but the origin
 of the operation (also for the interpretation of the passed in key) is a
 tracked node identified by the passed in <code>NodeSelector</code>. The
 selector can be <b>null</b>, then the root node is assumed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key</dd>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the root node (or
        <b>null</b>)</dd>
<dd><code>value</code> - the new value for this property</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector cannot be resolved</dd>
</dl>
</li>
</ul>
<a name="clearTree-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearTree</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&gt;&nbsp;clearTree(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                                  <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Removes the sub trees defined by the given key from this model. All nodes
 selected by this key are retrieved from the specified
 <code>NodeKeyResolver</code> and removed from the model. This implementation checks whether nodes become undefined
 after subtrees have been removed. If this is the case, such nodes are
 removed, too. Return value is a collection with <code>QueryResult</code>
 objects for the elements to be removed from the model.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#clearTree-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">clearTree</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key selecting the properties to be removed</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an object with information about the data removed</dd>
</dl>
</li>
</ul>
<a name="clearTree-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearTree</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&gt;&nbsp;clearTree(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                                  <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
                                                  <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Clears a whole sub tree using a tracked node as root node. This method
 works like the normal <code>clearTree()</code> method, but the origin of the
 operation (also for the interpretation of the passed in key) is a tracked
 node identified by the passed in <code>NodeSelector</code>. The selector can
 be <b>null</b>, then the root node is assumed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key</dd>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the root node (or
        <b>null</b>)</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a list with the results to be removed</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector cannot be resolved</dd>
</dl>
</li>
</ul>
<a name="clearProperty-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearProperty</h4>
<pre>public&nbsp;void&nbsp;clearProperty(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                          <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Clears the value of a property. This method is similar to
 <a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#clearTree-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-"><code>NodeModel.clearTree(String, NodeKeyResolver)</code></a>: However, the nodes
 referenced by the passed in key are not removed completely, but only
 their value is set to <b>null</b>. If this operation leaves an affected node in an undefined
 state, it is removed from the model.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#clearProperty-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">clearProperty</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key selecting the properties to be cleared</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
</dl>
</li>
</ul>
<a name="clearProperty-java.lang.String-org.apache.commons.configuration2.tree.NodeSelector-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearProperty</h4>
<pre>public&nbsp;void&nbsp;clearProperty(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                          <a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
                          <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Clears a property using a tracked node as root node. This method works
 like the normal <code>clearProperty()</code> method, but the origin of the
 operation (also for the interpretation of the passed in key) is a tracked
 node identified by the passed in <code>NodeSelector</code>. The selector can
 be <b>null</b>, then the root node is assumed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key</dd>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the root node (or
        <b>null</b>)</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector cannot be resolved</dd>
</dl>
</li>
</ul>
<a name="clear-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clear</h4>
<pre>public&nbsp;void&nbsp;clear(<a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Removes all data from this model. A new empty root node is created with the same name as the
 current root node. Implementation note: Because this is a hard reset the
 usual dance for dealing with concurrent updates is not required here.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#clear-org.apache.commons.configuration2.tree.NodeKeyResolver-">clear</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
</dl>
</li>
</ul>
<a name="getInMemoryRepresentation--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getInMemoryRepresentation</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;getInMemoryRepresentation()</pre>
<div class="block">Returns a representation of the data stored in this model in form of a
 nodes hierarchy of <code>ImmutableNode</code> objects. A concrete model
 implementation can use an arbitrary means to store its data. When a
 model's data is to be used together with other functionality of the
 <em>Configuration</em> library (e.g. when combining multiple
 configuration sources) it has to be transformed into a common format.
 This is done by this method. <code>ImmutableNode</code> is a generic
 representation of a hierarchical structure. Thus, it should be possible
 to generate a corresponding structure from arbitrary model data. This implementation simply returns the current root node of this
 model.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#getInMemoryRepresentation--">getInMemoryRepresentation</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the root node of an in-memory hierarchy representing the data
         stored in this model</dd>
</dl>
</li>
</ul>
<a name="setRootNode-org.apache.commons.configuration2.tree.ImmutableNode-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setRootNode</h4>
<pre>public&nbsp;void&nbsp;setRootNode(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;newRoot)</pre>
<div class="block">Sets a new root node for this model. The whole structure is replaced by
 the new node and its children. All tracked nodes and reference objects managed by this
 model are cleared.Care has to be taken when this method is used and the
 model is accessed by multiple threads. It is not deterministic which
 concurrent operations see the old root and which see the new root node.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html#setRootNode-T-">setRootNode</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeModel.html" title="interface in org.apache.commons.configuration2.tree">NodeModel</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>newRoot</code> - the new root node to be set (can be <b>null</b>, then an
        empty root node is set)</dd>
</dl>
</li>
</ul>
<a name="replaceRoot-org.apache.commons.configuration2.tree.ImmutableNode-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>replaceRoot</h4>
<pre>public&nbsp;void&nbsp;replaceRoot(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;newRoot,
                        <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Replaces the root node of this model. This method is similar to
 <a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#setRootNode-org.apache.commons.configuration2.tree.ImmutableNode-"><code>setRootNode(ImmutableNode)</code></a>; however, tracked nodes will not get
 lost. The model applies the selectors of all tracked nodes on the new
 nodes hierarchy, so that corresponding nodes are selected (this may cause
 nodes to become detached if a select operation fails). This operation is
 useful if the new nodes hierarchy to be set is known to be similar to the
 old one. Note that reference objects are lost; there is no way to
 automatically match nodes between the old and the new nodes hierarchy.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>newRoot</code> - the new root node to be set (must not be <b>null</b>)</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the new root node is <b>null</b></dd>
</dl>
</li>
</ul>
<a name="mergeRoot-org.apache.commons.configuration2.tree.ImmutableNode-java.lang.String-java.util.Map-java.lang.Object-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>mergeRoot</h4>
<pre>public&nbsp;void&nbsp;mergeRoot(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node,
                      <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;rootName,
                      <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>,?&gt;&nbsp;references,
                      <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;rootRef,
                      <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Merges the root node of this model with the specified node. This method
 is typically caused by configuration implementations when a configuration
 source is loaded, and its data has to be added to the model. It is
 possible to define the new name of the root node and to pass in a map
 with reference objects.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the node to be merged with the root node</dd>
<dd><code>rootName</code> - the new name of the root node; can be <b>null</b>, then
        the name of the root node is not changed unless it is <b>null</b></dd>
<dd><code>references</code> - an optional map with reference objects</dd>
<dd><code>rootRef</code> - an optional reference object for the new root node</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
</dl>
</li>
</ul>
<a name="trackNode-org.apache.commons.configuration2.tree.NodeSelector-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>trackNode</h4>
<pre>public&nbsp;void&nbsp;trackNode(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
                      <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Adds a node to be tracked. After this method has been called with a
 specific <code>NodeSelector</code>, the node associated with this key can be
 always obtained using <a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#getTrackedNode-org.apache.commons.configuration2.tree.NodeSelector-"><code>getTrackedNode(NodeSelector)</code></a> with the same
 selector. This is useful because during updates of a model parts of the
 structure are replaced. Therefore, it is not a good idea to simply hold a
 reference to a node; this might become outdated soon. Rather, the node
 should be tracked. This mechanism ensures that always the correct node
 reference can be obtained.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the desired node</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector does not select a
         single node</dd>
</dl>
</li>
</ul>
<a name="selectAndTrackNodes-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>selectAndTrackNodes</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&gt;&nbsp;selectAndTrackNodes(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                                    <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Allows tracking all nodes selected by a key. This method evaluates the
 specified key on the current nodes structure. For all selected nodes
 corresponding <code>NodeSelector</code> objects are created, and they are
 tracked. The returned collection of <code>NodeSelector</code> objects can be
 used for interacting with the selected nodes.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key for selecting the nodes to track</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a collection with the <code>NodeSelector</code> objects for the new
         tracked nodes</dd>
</dl>
</li>
</ul>
<a name="trackChildNodes-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>trackChildNodes</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&gt;&nbsp;trackChildNodes(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                                <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Tracks all nodes which are children of the node selected by the passed in
 key. If the key selects exactly one node, for all children of this node
 <code>NodeSelector</code> objects are created, and they become tracked nodes.
 The returned collection of <code>NodeSelector</code> objects can be used for
 interacting with the selected nodes.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key for selecting the parent node whose children are to be
        tracked</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a collection with the <code>NodeSelector</code> objects for the new
         tracked nodes</dd>
</dl>
</li>
</ul>
<a name="trackChildNodeWithCreation-java.lang.String-java.lang.String-org.apache.commons.configuration2.tree.NodeKeyResolver-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>trackChildNodeWithCreation</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;trackChildNodeWithCreation(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                               <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;childName,
                                               <a href="../../../../../org/apache/commons/configuration2/tree/NodeKeyResolver.html" title="interface in org.apache.commons.configuration2.tree">NodeKeyResolver</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;resolver)</pre>
<div class="block">Tracks a node which is a child of another node selected by the passed in
 key. If the selected node has a child node with this name, it is tracked
 and its selector is returned. Otherwise, a new child node with this name
 is created first.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key for selecting the parent node</dd>
<dd><code>childName</code> - the name of the child node</dd>
<dd><code>resolver</code> - the <code>NodeKeyResolver</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <code>NodeSelector</code> for the tracked child node</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the passed in key does not
         select a single node</dd>
</dl>
</li>
</ul>
<a name="getTrackedNode-org.apache.commons.configuration2.tree.NodeSelector-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTrackedNode</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;getTrackedNode(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector)</pre>
<div class="block">Returns the current <code>ImmutableNode</code> instance associated with the
 given <code>NodeSelector</code>. The node must be a tracked node, i.e.
 <a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModel.html#trackNode-org.apache.commons.configuration2.tree.NodeSelector-org.apache.commons.configuration2.tree.NodeKeyResolver-"><code>trackNode(NodeSelector, NodeKeyResolver)</code></a> must have been called
 before with the given selector.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the desired node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the current <code>ImmutableNode</code> associated with this selector</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector is unknown</dd>
</dl>
</li>
</ul>
<a name="replaceTrackedNode-org.apache.commons.configuration2.tree.NodeSelector-org.apache.commons.configuration2.tree.ImmutableNode-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>replaceTrackedNode</h4>
<pre>public&nbsp;void&nbsp;replaceTrackedNode(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector,
                               <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;newNode)</pre>
<div class="block">Replaces a tracked node by another node. If the tracked node is not yet
 detached, it becomes now detached. The passed in node (which must not be
 <b>null</b>) becomes the new root node of an independent model for this
 tracked node. Further updates of this model do not affect the tracked
 node's model and vice versa.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the tracked node</dd>
<dd><code>newNode</code> - the node replacing the tracked node (must not be
        <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector cannot be resolved</dd>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the replacement node is <b>null</b></dd>
</dl>
</li>
</ul>
<a name="getTrackedNodeHandler-org.apache.commons.configuration2.tree.NodeSelector-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTrackedNodeHandler</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&gt;&nbsp;getTrackedNodeHandler(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector)</pre>
<div class="block">Returns a <code>NodeHandler</code> for a tracked node. Such a handler may be
 required for operations on a sub tree of the model. The handler to be
 returned depends on the current state of the tracked node. If it is still
 active, a handler is used which shares some data (especially the parent
 mapping) with this model. Detached track nodes in contrast have their own
 separate model; in this case a handler associated with this model is
 returned.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the tracked node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a <code>NodeHandler</code> for this tracked node</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector is unknown</dd>
</dl>
</li>
</ul>
<a name="isTrackedNodeDetached-org.apache.commons.configuration2.tree.NodeSelector-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isTrackedNodeDetached</h4>
<pre>public&nbsp;boolean&nbsp;isTrackedNodeDetached(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector)</pre>
<div class="block">Returns a flag whether the specified tracked node is detached. As long as
 the <code>NodeSelector</code> associated with that node returns a single
 instance, the tracked node is said to be <em>life</em>. If now an update
 of the model happens which invalidates the selector (maybe the target
 node was removed), the tracked node becomes detached. It is still
 possible to query the node; here the latest valid instance is returned.
 But further changes on the node model are no longer tracked for this
 node. So even if there are further changes which would make the
 <code>NodeSelector</code> valid again, the tracked node stays in detached
 state.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the desired node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a flag whether this tracked node is in detached state</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the selector is unknown</dd>
</dl>
</li>
</ul>
<a name="untrackNode-org.apache.commons.configuration2.tree.NodeSelector-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>untrackNode</h4>
<pre>public&nbsp;void&nbsp;untrackNode(<a href="../../../../../org/apache/commons/configuration2/tree/NodeSelector.html" title="class in org.apache.commons.configuration2.tree">NodeSelector</a>&nbsp;selector)</pre>
<div class="block">Removes a tracked node. This method is the opposite of
 <code>trackNode()</code>. It has to be called if there is no longer the need
 to track a specific node. Note that for each call of <code>trackNode()</code>
 there has to be a corresponding <code>untrackNode()</code> call. This ensures
 that multiple observers can track the same node.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>selector</code> - the <code>NodeSelector</code> defining the desired node</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/ex/ConfigurationRuntimeException.html" title="class in org.apache.commons.configuration2.ex">ConfigurationRuntimeException</a></code> - if the specified node is not
         tracked</dd>
</dl>
</li>
</ul>
<a name="getReferenceNodeHandler--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getReferenceNodeHandler</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/ReferenceNodeHandler.html" title="interface in org.apache.commons.configuration2.tree">ReferenceNodeHandler</a>&nbsp;getReferenceNodeHandler()</pre>
<div class="block">Returns a <code>ReferenceNodeHandler</code> object for this model. This
 extended node handler can be used to query references objects stored for
 this model.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <code>ReferenceNodeHandler</code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/InMemoryNodeModel.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.Builder.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/tree/InMemoryNodeModelSupport.html" title="interface in org.apache.commons.configuration2.tree"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/tree/InMemoryNodeModel.html" target="_top">Frames</a></li>
<li><a href="InMemoryNodeModel.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
